"""
    Production API

    API exposing endpoints for managing well headers and daily production.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from openapi_client.api_client import ApiClient, Endpoint
from openapi_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from openapi_client.model.formation_property import FormationProperty
from openapi_client.model.formation_property_entity import FormationPropertyEntity
from openapi_client.model.formation_property_input import FormationPropertyInput


class FormationPropertyApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __production_get_formation_property(
            self,
            uwi,
            wellbore_index,
            **kwargs
        ):
            """Fetch formation property by well   # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.production_get_formation_property(uwi, wellbore_index, async_req=True)
            >>> result = thread.get()

            Args:
                uwi (str):
                wellbore_index (int):

            Keyword Args:
                page (int): [optional]
                limit (int): [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [FormationPropertyEntity]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['uwi'] = \
                uwi
            kwargs['wellbore_index'] = \
                wellbore_index
            return self.call_with_http_info(**kwargs)

        self.production_get_formation_property = Endpoint(
            settings={
                'response_type': ([FormationPropertyEntity],),
                'auth': [
                    'bearerAuth'
                ],
                'endpoint_path': '/api/production/formationProperty/{uwi}/{wellboreIndex}',
                'operation_id': 'production_get_formation_property',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'uwi',
                    'wellbore_index',
                    'page',
                    'limit',
                ],
                'required': [
                    'uwi',
                    'wellbore_index',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'uwi':
                        (str,),
                    'wellbore_index':
                        (int,),
                    'page':
                        (int,),
                    'limit':
                        (int,),
                },
                'attribute_map': {
                    'uwi': 'uwi',
                    'wellbore_index': 'wellboreIndex',
                    'page': 'page',
                    'limit': 'limit',
                },
                'location_map': {
                    'uwi': 'path',
                    'wellbore_index': 'path',
                    'page': 'query',
                    'limit': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json',
                    'application/x-ndjson'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__production_get_formation_property
        )

        def __production_upsert_formation_property(
            self,
            uwi,
            wellbore_index,
            formation_property_input,
            **kwargs
        ):
            """Bulk Add / Update Formation Property Data  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.production_upsert_formation_property(uwi, wellbore_index, formation_property_input, async_req=True)
            >>> result = thread.get()

            Args:
                uwi (str):
                wellbore_index (int):
                formation_property_input ([FormationPropertyInput]):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [FormationProperty]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['uwi'] = \
                uwi
            kwargs['wellbore_index'] = \
                wellbore_index
            kwargs['formation_property_input'] = \
                formation_property_input
            return self.call_with_http_info(**kwargs)

        self.production_upsert_formation_property = Endpoint(
            settings={
                'response_type': ([FormationProperty],),
                'auth': [
                    'bearerAuth'
                ],
                'endpoint_path': '/api/production/formationProperty/{uwi}/{wellboreIndex}',
                'operation_id': 'production_upsert_formation_property',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'uwi',
                    'wellbore_index',
                    'formation_property_input',
                ],
                'required': [
                    'uwi',
                    'wellbore_index',
                    'formation_property_input',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'uwi':
                        (str,),
                    'wellbore_index':
                        (int,),
                    'formation_property_input':
                        ([FormationPropertyInput],),
                },
                'attribute_map': {
                    'uwi': 'uwi',
                    'wellbore_index': 'wellboreIndex',
                },
                'location_map': {
                    'uwi': 'path',
                    'wellbore_index': 'path',
                    'formation_property_input': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json',
                    'application/x-ndjson'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__production_upsert_formation_property
        )
